;=================================================
no_event:
	call	has_item_ret_no

	ld	c,a			;a'<-original item ID
	ex	af,af'			
	ld	a,c
	inc	a			;look up the next structure
	call	look_up_item_structure	;hl<-item structure
	dec	hl			;last entry of previous item
	ld	a,(hl)
	cp	1
	jr	nz,destroy_item			
replaceable_item:
	ld	a,(de)			;what's on the ground
	dec	hl
	dec	hl
	dec	hl
	cp	(hl)			;compare it with what it's supposed to be
	ret	nz			;if they're different, get out
item_to_be_placed:
	ex	de,hl
	ex	af,af'	
	ld	(hl),a			;load tile id into the ground
	inc	hl			;
	ld	(hl),09h		;the pickup event (event 1)
		
	xor	a
	ld	(item_contents),a	;no item in hands now
	jp	super_update

destroy_item:
	ld	(animation_length),a
	ex	af,af'
	call	look_up_item_image
	push	hl
	ld	bc,32			
	add	hl,bc
	ex	de,hl
	exx
	pop	bc
	jp	item_drop

infinite_pickup:
	ld	a,(item_contents)
	or	a
	jp	nz,no_event
;=================================================
grab_item:
	call has_item_ret_yes
	ld	h,a			;ld h,0
	ld	a,(gen_state)
	rrca
	rrca				;x64
	ld	l,a
	ld	b,h
	ld	c,a
	add	hl,bc			;x128
	add	hl,bc			;x192 (size of two frames of animation)
	ld	bc,pick_up_states
	add	hl,bc
grab_animate:
	push	hl
	ld	b,h
	ld	c,l
	exx				;map ptr goes prime, disp_screen doesn't touch de'
	pop	de
	ld	hl,48
	add	hl,de
	ex	de,hl

	call	display_screen_lemme_do_it

	ex	de,hl
	exx				;restore map ptr
	inc	d
	dec	d
	jr	z,finish_grab
	ld	a,(de)			;item ID
	push	af
	call	look_up_item_structure
	ldi				;new ID from structure into map
	ldi				;new flags from structure into map
	call	cycle_state		;foot moving looks stupid
patch_while_down = $+1
	ld	a,95
	call	synchronize_skip
	exx
	ld	d,0
	jr	grab_animate
finish_grab:
	pop	af
	call	load_item
	call	update_full
	call	align_shifts
	ld	a,70
	call	synchronize_skip
	jp	display_screen
;=================================================
force_bed:	
	ld	a,(in_shop)
	or	a
	jr	nz,skip_bed

	ld	(gen_state),a		;face down please

	dec	a
	call	clear_vid

	call	display_screen_clear

	call	long_synchronize

	ld	a,walk_speed
	ld	(speed),a

	call	cycle_state

	ld	de,inside-inside_mapwidth+2
	call	enter_house_force

	ld	hl,force_string
	call	display_text
	call	goin_to_bed
skip_bed:
	ld	hl,game_loop
	ld	(mod_frame_final),hl
	jp	game_loop
;=================================================
go_to_bed:
	ld	hl,bed_string
	call	display_text

	call	prepare_yes_or_no
	jp	z,menu_choice_no
goin_to_bed:
	ld	a,$FF
	call	clear_vid

	call	display_screen_clear

	ld	hl,00F8h
	ld	(shift_h),hl
	ld	a,h
	ld	(gen_state),a

	ld	hl,inside-inside_mapwidth
	ld	(map),hl

	call	start_new_day
	jr	skip_bed		;avoid that problem where it mods it before it changes the time
;=================================================
house_door:
	ld	de,inside+(2*26)
enter_house_force:
	ld	hl,inside_load
pre_exit: 
	ld	bc,00F9h
exit_and_enter:
	ld	(shift_h),bc
adapt_load:
	call	load_map_and_level
	jp	super_update
load_map_and_level:
	ld	(map),de
	call	load_level
	ret
;=================================================
exit_door:
	ld	a,(watering_can_alive)
	or	a
	ret	z
	ld	hl,outside_load
	ld	de,outside+outside_mapwidth-2
	jr	pre_exit
;=================================================
chicken_door:
	ld	hl,chicken_coop_load
	ld	de,chicken_coop+20+2
	jr	entering_no_force
;=================================================
exit_coop:
	ld	de,outside+(1*outside_mapwidth)+12
	ld	hl,outside_load
	jr	exiting_no_force
;=================================================
shop_door:
	ld	hl,shop_load
	ld	de,shop+(4*20)+2
entering_no_force:
	ld	a,h
	ld	(in_shop),a
	jr	item_block_save
;=================================================
exit_shop:
	ld	hl,town_load
	ld	de,town+(4*26)+2
exiting_no_force:
	xor	a
	ld	(in_shop),a
item_block_save:
	call	has_item_ret_yes		;NO STEALIN
	jr	pre_exit
;=================================================
shipping_box:
	call	has_item_ret_no
	
	ld	a,bbbl				;2
	ld	(outside+(2*4)+(outside_mapwidth*9)),a	;3
	ld	(chicken_coop+(2*7)+(chicken_coop_mapwidth*3)),a
	inc	a			;1
	ld	(outside+(2*5)+(outside_mapwidth*9)),a	;3
	inc	a				;1
	ld	(outside+(2*4)+(outside_mapwidth*8)),a	;3
	ld	(chicken_coop+(2*7)+(chicken_coop_mapwidth*2)),a
	inc	a				;1
	ld	(outside+(2*5)+(outside_mapwidth*8)),a	;3

	ld	de,(item_contents)
	ld	hl,sell_table
	xor	a
	ld	d,a
	add	hl,de
	
	ld	e,(hl)			;item's sell cost
	ld	hl,(money)
	add	hl,de
	ld	(money),hl
victory_check:
	jr	$+2
	ld	de,17000		;the winning amount
	sbc	hl,de
	jr	nc,victory
skip_victory_check:
	ld	(item_contents),a
	call	super_update
mod_speed = $+1
	ld	a,140
	call	synchronize_skip
	
;return to normal
	ld	a,sbbl
	ld	(outside+(2*4)+(outside_mapwidth*9)),a
	ld	(chicken_coop+(2*7)+(chicken_coop_mapwidth*3)),a
	inc	a
	ld	(outside+(2*5)+(outside_mapwidth*9)),a
	inc	a
	ld	(outside+(2*4)+(outside_mapwidth*8)),a
	ld	(chicken_coop+(2*7)+(chicken_coop_mapwidth*2)),a
	inc	a
	ld	(outside+(2*5)+(outside_mapwidth*8)),a
ship_box_mod:
	jp	super_update
victory:
	ld	(item_contents),a

	ld	a,7
	ld	(victory_check+1),a	

	ld	hl,win_str
	jp	display_text
;=================================================
chicken_feed:
	ld	a,(item_contents)
	or	a
	ld	hl,feed_counter
	jr	nz,feed_in_hands

	cp	(hl)
	ret	z
	dec	(hl)

	ld	a,chfd
	jr	finish_feed
feed_in_hands:
	cp	chik
	ret	z			;no selling the chickens ...
	cp	chfd			;we're selling any item but chicken feed.
					;or chickens
	jr	nz,shipping_box		;it'll animate
	inc	(hl)			;update the counter ...
	jr	remove_item		;take the item away
;=================================================
acquire_tool:
tool_threshold = 4
	call	grab_item
	ld	a,(item_contents)
	sub	tool_threshold			;carry reset

	rla
	rla

	ld	h,0
	ld	l,a
	ld	de,tool_array
	add	hl,de
	ld	(tool),hl
	ld	a,(hl)
	inc	hl
	inc	hl
	ld	(hl),h
	inc	hl
	dec	a
	jr	nz,skip_quantity
	inc	(hl)			;this is why we get 1 fodder ... wtf.
skip_quantity:
	ld	a,100
	call	synchronize_skip
	call	display_change_item	
	call	long_synchronize
	jr	remove_item
;=================================================
wood_shed:
	ld	a,(item_contents)
	or	a
	jr	nz,something_in_hands

	ld	a,mpst
finish_feed:
	ld	(item_contents),a

	call	load_item
wood_shed_jump:
	jp	display_screen

something_in_hands:
	cp	mpst
	ret	nz
remove_item:
kill_item:
	xor	a
	ld	(item_contents),a
	jp	display_screen
;=================================================
accept_feed:
	call	has_item_ret_no
	cp	corn
	ret	nz
accepted_feed:
	ld	hl,feed_counter
	inc	(hl)
	jr	remove_item
;=================================================
chicken_drop:
	ld	a,(de)
	cp	path
	ret	nz			;ignore the event unless it's assigned to path
					;a good escape event

	ld	a,(item_contents)
	cp	chfd
	jr	z,drop_feed_no_col
	cp	chik
	jp	nz,no_event

	ld	hl,done_item_drop
	ld	(hl),$C9
	push	hl

	push	de
	call	no_event
	pop	hl
	ld	(hl),chik
	inc	hl
	ld	(hl),09h
	pop	hl
	ld	(hl),$C3
chick_super:
	jp	super_update
drop_feed_no_col:
	ld	(de),a
	inc	de
	ex	de,hl
	ld	(hl),08h		;no collision pick up event
	call	super_update
	jr	remove_item
;=================================================
watch_tv:
	ld	a,(random_seed+1)		;same text all day every day
	and	00000011b			;since only gens randoms overnight
	or	a
	jr	z,tv0
	dec	a
	jr	z,tv1
	dec	a
	jr	z,tv2
tv3:
	ld	hl,tv_message3
	jr	rock_save_byte
tv2:
	ld	hl,tv_message2
	jr	rock_save_byte
tv1:
	ld	hl,tv_message1
	jr	rock_save_byte
tv0:
	ld	hl,tv_message0
	jr	rock_save_byte
;=================================================
read_sign:
	ld	hl,sign_string
rock_save_byte:
	jp	display_text	
heavy_rock:
	call	has_item_ret_yes
	ld	hl,heavy_rock_text
	jr	rock_save_byte
;=================================================
goto_town:
	ld	hl,outside+(6*outside_mapwidth)-2
	ld	(map),hl
	ld	hl,0FB0Ah
	ld	(shift_h),hl

	ld	hl,town+(9*26)+20
	ld	a,path
	ld	(de),a
	ld	(hl),a
	push	hl
	push	de

	inc	hl
	inc	de
	xor	a

	ld	(de),a
	ld	(hl),a

	call	super_update

	ld	hl,town_load	
	ld	de,town+(6*26)+24
	call	load_map_and_level

	ld	a,run_speed
	ld	(speed),a

	ld	b,6*16+4
move_left_loop:
	push	bc
	call	no_collision_left

	call	next_state
	call	synchronize

	pop	bc
	djnz	move_left_loop
	jr	finish_runs
;=================================================
return_from_town:
	ld	hl,town+(6*26)+10
	ld	(map),hl
	ld	hl,0FBF7h
	ld	(shift_h),hl

	ex	de,hl
	push	hl
	xor	a
	ld	(hl),path
	inc	hl
	ld	(hl),a

	ld	hl,outside+(9*outside_mapwidth)+2
	push	hl
	ld	(hl),path
	inc	hl
	ld	(hl),a

	call	super_update

	ld	hl,outside_load	
	ld	de,outside+(6*outside_mapwidth)-16		;-14;-12;-10;-8;-6;-4;-2;ot;	
	call	load_map_and_level

	ld	a,run_speed
	ld	(speed),a

	ld	b,6*16+4
move_right_loop:
	push	bc
	call	no_collision_right

	call	next_state
	call	synchronize

	pop	bc
	djnz	move_right_loop
finish_runs:
	pop	hl
	ld	(hl),gate
	inc	hl
	ld	(hl),51h

	pop	hl
	ld	(hl),gate
	inc	hl
	ld	(hl),59h

	jp	super_update
;=================================================
refill_watering_can:
	ex	de,hl
	ld	a,(hl)
	ld	(hl),4		;refill

	ld	(refill_watering_can_bg),a	

	push	af
	ld	a,180
	ld	(patch_while_down),a

	push	hl
	call	locate_target_square
	ex	de,hl
	call	grab_item
	pop	hl

	pop	af

	ld	(hl),a
	inc	hl
	ld	(hl),61h

	ld	a,95
	ld	(patch_while_down),a

	ld	a,145
	call	synchronize_skip

	xor	a
	ld	(item_contents),a
max_water_level = $+1
	ld	a,16
	ld	(water_level),a
super_shortcut:
	jp	super_update
;=================================================
harvest_elf:
	call	has_item_ret_yes

	ld	hl,elf_harvest
	call	display_text

	call	prepare_yes_or_no
	jr	nz,begin_fast_harvest

	call	wait_for_second_up
	jr	super_shortcut

begin_fast_harvest:
	ld	de,300
	call	transaction

	ld	hl,0000h
	ld	(shift_h),hl

	ld	hl,outside+(2*2)+(outside_mapwidth*6)
	ld	(map),hl

	ld	hl,mod_speed
	ld	(hl),45
	push	hl

	ld	a,4
	ld	(gen_state),a

	call	cycle_state

	call	super_update

	ld	hl,outside+1
	ld	bc,610
fast_harvest_loop:
	ld	a,09h
	cp	(hl)
	jr	nz,not_harvestable

	dec	hl
	ld	a,0Ch-1
	cp	(hl)
	jr	nc,pre_not_harvestable
	
	ld	a,(hl)
	ld	(item_contents),a
	ex	de,hl	
	
	push	bc
	call	look_up_item_structure
	ldi
	ldi	
	push	de
		
	call	shipping_box
	ld	a,45
	call	synchronize_skip
	pop	hl
	pop	bc	
	jr	find_counters-1

pre_not_harvestable:
	inc	hl
not_harvestable:
	dec	bc
	dec	bc	
	inc	hl
	inc	hl
find_counters:
	ld	a,b
	or	c
	jr	nz,fast_harvest_loop
	ld	(gen_state),a

	ld	hl,outside+(4*2)+(11*outside_mapwidth)-8
	ld	(map),hl

	pop	hl
	ld	(hl),140
	jp	menu_choice_no
;=================================================
talk_shop:
	ld	a,(item_contents)
	or	a			;reset carry
	jr	nz,buy_tool

	ld	hl,shop_string
	jp	display_text	

buy_tool:
	rla			
	ld	l,a
	ld	h,0
	ld	de,buy_table
	add	hl,de
	ld	(tool_cost),hl

	ld	hl,choice_string
	call	display_text
buy_tool_skip:
	call	prepare_yes_or_no
	jp	z,menu_choice_no
yes_selected:
	ld	hl,(tool_cost)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	
	call	transaction	

	call	super_update
	jp	acquire_tool
too_much_tv_clock:
	pop	hl
too_much:
	ld	hl,not_enough_money
	call	display_text
	jp	wait_for_second_up
;=================================================
buy_chicken:
	ld	hl,chicken_buy_string
	ld	de,1000
	call	buy_large_item
finish_off_chicken:
	ld	a,path
	ld	de,(chik*256)+09h
	call	chicken_coop_s_n_d
	ld	hl,bought_chicken_str
	jp	display_text
;=================================================
buy_tv:
	ld	de,2000
	ld	hl,tv_string
	call	buy_large_item
finish_off_tv:
	ld	hl,shop+(2*5)+shop_mapwidth
	ld	(hl),wllp
	inc	hl
	inc	hl
	ld	(hl),wllp
	ld	hl,shop+(2*5)+(2*shop_mapwidth)
	ld	(hl),flor
	inc	hl
	ld	(hl),01h
	inc	hl
	ld	(hl),flor
	inc	hl
	ld	(hl),01h

	call	clear_synch_change
	exx
	push	hl

	ld	hl,inside+(2*8)+inside_mapwidth
	ld	a,tvbl
	ld	(hl),a
	inc	hl
	ld	(hl),41h
	inc	hl
	inc	a
	ld	(hl),a
	inc	hl
	ld	(hl),41h
	ld	hl,inside+(2*8)
	inc	a
	ld	(hl),a
	inc	hl
	inc	a
	inc	hl
	ld	(hl),a
	jr	finish_tv
;=================================================
buy_clock:
	ld	hl,clock_string
	ld	de,1500
	call	buy_large_item
finish_off_clock:					
	ld	hl,shop+(2*4)+shop_mapwidth
	ld	(hl),wllp
	inc	hl
	ld	(hl),01h
	ld	hl,shop+(2*4)+(2*shop_mapwidth)
	ld	(hl),flor
	inc	hl
	ld	(hl),01h

	call	clear_synch_change
	exx
	push	hl

	ld	hl,inside+(2*7)+inside_mapwidth
	ld	a,clkb
	ld	(hl),a
	inc	hl
	ld	(hl),$B9
	inc	a
	ld	(inside+(7*2)),a
finish_tv:
	call	long_synchronize
	call	update_full
	call	display_screen_clear
	call	long_synchronize
	call	synchronize_skip		;for super long synchronize

	pop	de
	ld	hl,shop_load
	jp	adapt_load

clear_synch_change:
	call	super_update
	call	long_synchronize
	ld	hl,(map)
	exx
	ld	de,inside-inside_mapwidth+8
	ld	hl,inside_load
	call	load_map_and_level			;doesn't change the shifts
	call	update_full
	jp	display_screen_clear

buy_large_item:
	push	de
	call	display_text
	call	prepare_yes_or_no
	pop	de
	jr	z,no_buy

	pop	bc
	call	transaction
	push	bc
	ret

no_buy:
	pop	de
menu_choice_no:
	call	wait_for_second_up
	jp	super_update
;=================================================
shop_sign:
	ld	hl,shop_sign_text
	jr	it_is_am+1	
;=================================================
read_clock:
	ld	de,clock_str
	ld	hl,hour
	bit	7,(hl)
	jr	nz,it_is_pm
it_is_am:
	ex	de,hl
	jp	display_text
it_is_pm:
	res	7,(hl)
	push	hl
	ex	de,hl
	call	display_text
	pop	hl
	set	7,(hl)	
	ret
;=================================================

;=================================================
talk_to_sprite:
	ld	a,(item_contents)
	or	a
	jr	z,normal_elf_text
check_if_like:
	;4,14 to ;4,13  when happy
	cp	tmto
	jr	z,love_tomato
not_tomato:
	ld	hl,elf_sad
	jr	disp_elf
love_tomato:
	xor	a
	ld	(item_contents),a
	ld	hl,outside+(4*2)+(14*outside_mapwidth)+1
	ld	(hl),a
	dec	hl
	ld	(hl),dirt
	ld	hl,outside+(4*2)+(13*outside_mapwidth)+1
	ld	(hl),$F9
	dec	hl
	ld	(hl),hspt		;replace with elf later
	ld	hl,elf_happy
	jr	disp_elf

normal_elf_text:
	ld	a,(random_seed)		;same text all day every day
	and	00000011b		;since only gens randoms overnight
	or	a
	jr	z,talk1
	dec	a
	jr	z,talk2
	dec	a
	jr	z,talk3
talk4:
	ld	hl,elf_string1
	jr	disp_elf
talk3:
	ld	hl,elf_string2
	jr	disp_elf
talk2:
	ld	hl,elf_string3
	jr	disp_elf
talk1:
	ld	hl,elf_string4
disp_elf:
	jp	display_text
;=================================================
get_money:
	ld	a,09h
	inc	de
	ld	(de),a
	ld	de,2000
	ld	hl,(money)
	add	hl,de
	ld	(money),hl
	call	super_update
	ld	hl,money_found
	call	display_text
	ld	a,post
	ld	(refill_watering_can_bg),a
	call	action				;run the grab item event

	call	display_change_item
	
	call	long_synchronize

	ld	hl,watering_legend
	call	display_text

	ld	hl,super_watering_can
	ld	(watering_can),hl
	jp	kill_item
;=================================================
feed_sign:
	ld	hl,feed_string
	jr	disp_elf
;=================================================
